<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/ThreadManagerSingle.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_thread_manager_single_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ThreadManagerSingle.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerSingle.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;exception&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    ThreadManagerSingle::ThreadManagerSingle (Data &amp;&amp; data)</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;        : ThreadManager(std::move(data))</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    { }</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_single.html#a61d1a6de5e616f5db41ada25c7656d5b">   11</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_thread_manager_single.html#a61d1a6de5e616f5db41ada25c7656d5b">ThreadManagerSingle::ProcessToBuffer</a> (std::vector&lt;char&gt; &amp; result)</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        std::vector&lt;char&gt; block(<a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>); <span class="comment">// buffer for a single block</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        result.resize(<a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> * <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a>-&gt;GetSignatureSize());</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="comment">// read block after block</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keywordtype">size_t</span> blockIndex = 0;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keywordflow">while</span> (<span class="keywordtype">size_t</span> <span class="keyword">const</span> sz = <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">m_InputFile</a>-&gt;TryRead(block.data(), block.size()))</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            <span class="keywordflow">if</span> (sz &lt; block.size())</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;            {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;                LOGMSG(trace) &lt;&lt; (1 + blockIndex) &lt;&lt; <span class="stringliteral">&quot; / &quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> &lt;&lt; <span class="stringliteral">&quot; Partial block size=&quot;</span> &lt;&lt; sz &lt;&lt; <span class="stringliteral">&quot; padding=&quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> - sz;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;                memset(block.data() + sz, 0, block.size() - sz);</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            }</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                LOGMSG(trace) &lt;&lt; (1 + blockIndex) &lt;&lt; <span class="stringliteral">&quot; / &quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> &lt;&lt; <span class="stringliteral">&quot; Full block size=&quot;</span> &lt;&lt; sz;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            }</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="comment">// the place to store signature for this block</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            <span class="keywordtype">char</span> * <span class="keyword">const</span> result_ptr = result.data() + blockIndex * <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a>-&gt;GetSignatureSize();</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            <span class="comment">// calculate signature</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a>-&gt;CalculateSignature(block.data(), block.size(), result_ptr);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            ++blockIndex;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    }</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;} <span class="comment">// namespace siggen</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="astructsiggen_1_1_data_html_aaf8091edab7f24f7b6f725f6abbacc23"><div class="ttname"><a href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">siggen::Data::m_InputBlockCount</a></div><div class="ttdeci">size_t m_InputBlockCount</div><div class="ttdoc">block count (number of generated signatures)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00016">Data.h:16</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_single_html_a61d1a6de5e616f5db41ada25c7656d5b"><div class="ttname"><a href="classsiggen_1_1_thread_manager_single.html#a61d1a6de5e616f5db41ada25c7656d5b">siggen::ThreadManagerSingle::ProcessToBuffer</a></div><div class="ttdeci">virtual void ProcessToBuffer(std::vector&lt; char &gt; &amp;result) override</div><div class="ttdoc">calculates block-wise signature of input file and writes result to buffer</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_single_8cpp_source.html#l00011">ThreadManagerSingle.cpp:11</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a06a7600d0e0634bbb0275b81589fd5aa"><div class="ttname"><a href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">siggen::Data::m_Hash</a></div><div class="ttdeci">std::unique_ptr&lt; HashBase &gt; m_Hash</div><div class="ttdoc">signature function</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00020">Data.h:20</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a1006e97814f7d32c8668575d56ba8bdf"><div class="ttname"><a href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">siggen::Data::m_BlockSize</a></div><div class="ttdeci">size_t m_BlockSize</div><div class="ttdoc">block size specified from options</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00014">Data.h:14</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a09582db7e870dfdd031c9076338384cb"><div class="ttname"><a href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">siggen::Data::m_InputFile</a></div><div class="ttdeci">std::unique_ptr&lt; File &gt; m_InputFile</div><div class="ttdoc">input file (binary)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00019">Data.h:19</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_html_acf2e72bb7f780cd77fd9f046c5f8c66c"><div class="ttname"><a href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">siggen::ThreadManager::m_Data</a></div><div class="ttdeci">Data m_Data</div><div class="ttdoc">configuration for a thread manager</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_8h_source.html#l00014">ThreadManager.h:14</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>ThreadManagerSingle.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
